config/routes.rb
if ENV['RAILS_RELATIVE_URL_ROOT']
  Rails.application.routes.default_scope = ENV['RAILS_RELATIVE_URL_ROOT']
end

Rails.application.routes.draw do
  get 'up', to: ->(env) { [204, {}, ['']] }

  # ------------------------------------------------------------ Authentication
  # Sign in / sign out
  get '/login'  => 'sessions#new'
  get '/logout' => 'sessions#destroy'
  resource :session

  resources :comments

  # ------------------------------------------------------------ Project routes
  concern :multiple_destroy do
    collection do
      delete :multiple_destroy
    end
  end

  concern :multiple_update do
    collection do
      patch :multiple_update
    end
  end

  concern :previewable do
    member do
      post :preview
    end
  end

  resources :notifications, only: [:index, :update]

  resources :projects, only: [:index, :show] do
    resources :activities, only: [:index] do
      collection do
        get :poll, constraints: { format: /js/ }
      end
    end

    resources :boards do
      resources :lists, except: [:index] do
        member { post :move }
        resources :cards, except: [:index] do
          member { post :move }
          resources :revisions, only: [:index, :show]
        end
      end
    end

    constraints id: %r{[(0-z)\/]+} do
      resources :configurations, only: [:index, :update]
    end

    post :create_multiple_evidence, to: 'issues/evidence#create_multiple'

    resources :issues, concerns: [:multiple_destroy, :previewable] do
      collection do
        post :import
        resources :merge, only: [:new, :create], controller: 'issues/merge'
      end

      resources :evidence, concerns: :multiple_destroy, controller: 'issues/evidence', only: [:index, :new]
      resources :nodes, only: [:show], controller: 'issues/nodes'
      resources :revisions, only: [:index, :show]
    end

    resources :methodologies do
      collection { post :preview }
      member do
        get :add
        put :update_task
      end
    end

    resources :nodes do
      collection do
        post :sort
        post :create_multiple
      end

      member do
        get :tree
      end

      resource :merge, only: [:create], controller: 'nodes/merge'

      resources :notes, concerns: [:multiple_destroy, :previewable] do
        resources :revisions, only: [:index, :show]
      end

      resources :evidence, except: :index, concerns: [:multiple_destroy, :previewable] do
        resources :revisions, only: [:index, :show]
      end

      constraints(filename: /.*/) do
        resources :attachments, only: [:index, :show, :create, :destroy], param: :filename
      end
    end

    resources :notifications, only: [:index, :update]

    resources :revisions, only: [] do
      member { post :recover }
    end

    resources :tags, except: [:show] do
      collection { post :sort }
    end

    namespace :qa do
      resources :issues, only: [:edit, :index, :show, :update], concerns: [:multiple_update, :previewable]
    end

    get 'search' => 'search#index'
    get 'trash' => 'revisions#trash'

    # ------------------------------------------------------- Export Manager
    get  '/export' => 'export#index', as: :export_manager

    # ------------------------------------------------------- Upload Manager
    get  '/upload'        => 'upload#index',  as: :upload_manager
    post '/upload'        => 'upload#create'
    post '/upload/parse'  => 'upload#parse'

    if Rails.env.development?
      get '/styles' => 'styles_tylium#index'
    end
  end

  resources :console, only: [] do
    collection { get :status }
  end

  resource :fields, only: [] do
    collection do
      get :field
      post :form
      post :source
    end
  end

  namespace :setup, only: [:index] do
    if defined?(Dradis::Pro)
    else
      resource :password, only: [:new, :create]
    end
    resource :kit, only: [:new, :create]
  end

  resources :subscriptions, only: [:index, :create, :destroy]

  # -------------------------------------------------------------- Static pages
  resource :markup, controller: :markup, only: [] do
    get :help
    post :preview
  end

  if defined?(Dradis::Pro)
  else
    root to: 'setup/passwords#new'
  end

  mount ActionCable.server => '/cable'
end

app/controllers/issues/evidence_controller.rb
class Issues::EvidenceController < AuthenticatedController
  include ActivityTracking
  include ContentFromTemplate
  include DynamicFieldNamesCacher
  include MultipleDestroy
  include ProjectScoped

  before_action :set_issues, only: [:create_multiple, :index, :new]
  before_action :set_affected_nodes, only: :index
  before_action :set_auto_save_key, only: :new
  before_action :set_columns, only: :index

  def index
    render layout: false
  end

  def new
    @nodes_for_add_evidence = current_project.nodes.user_nodes.order(:label)

    @template_content = template_content if params[:template]
  end

  def create_multiple
    # validate Issue
    @issue = current_project.issues.find(evidence_params[:issue_id])

    if node_params_empty?
      @content = evidence_params[:content]
      @nodes_for_add_evidence = current_project.nodes.user_nodes.order(:label)

      flash.now[:alert] = 'A node must be selected.'
      return render :new
    end

    if params[:evidence][:node_ids]
      params[:evidence][:node_ids].reject(&:blank?).each do |node_id|
        node = current_project.nodes.find(node_id)
        evidence = Evidence.create!(
          author: current_user.email,
          content: evidence_params[:content],
          issue_id: @issue.id,
          node_id: node.id
        )
        track_created(evidence)
      end
    end

    if params[:evidence][:node_list]
      if params[:evidence][:node_list_parent_id].present?
        parent = current_project.nodes.find(params[:evidence][:node_list_parent_id])
      end
      params[:evidence][:node_list].lines.map(&:strip).reject(&:blank?).each do |label|
        unless (node = current_project.nodes.find_by(label: label))
          node = current_project.nodes.create!(
            type_id: Node::Types::HOST,
            label: label,
            parent: parent,
          )
          track_created(node)
        end

        evidence = Evidence.create!(
          author: current_user.email,
          content: evidence_params[:content],
          issue_id: @issue.id,
          node_id: node.id
        )
        track_created(evidence)
      end
    end

    redirect_to project_issue_path(current_project, evidence_params[:issue_id], tab: 'evidence-tab'), notice: 'Evidence added for selected nodes.'
  end

  private

  def evidence_params
    params.require(:evidence).permit(:author, :content, :issue_id, :node_id)
  end

  def node_params_empty?
    params[:evidence][:node_list].blank? &&
      (params[:evidence][:node_ids].reject(&:empty?).empty?)
  end

  def set_columns
    default_field_names = ['Label', 'Title'].freeze
    extra_field_names = ['Created', 'Created by', 'Updated'].freeze

    dynamic_fields = dynamic_field_names(@issue.evidence)

    rtp = current_project.report_template_properties
    rtp_default_fields = rtp ? rtp.evidence_fields.default.field_names : []

    @default_columns = rtp_default_fields.presence || default_field_names
    @all_columns = rtp_default_fields | dynamic_fields | extra_field_names
  end

  def set_affected_nodes
    @affected_nodes = Node.joins(:evidence)
                          .select('nodes.id, label, type_id, count(evidence.id) as evidence_count, nodes.updated_at')
                          .where('evidence.issue_id = ?', @issue.id)
                          .group('nodes.id')
                          .sort_by { |node, _| node.label }
  end

  def set_auto_save_key
    @auto_save_key =  if params[:template]
      "issue-#{params[:issue_id]}-evidence-#{params[:template]}"
    elsif params[:from_rtp]
      "issue-#{params[:issue_id]}-rtp-evidence"
    else
      "issue-#{params[:issue_id]}-evidence"
    end
  end

  def set_issues
    @issues = current_project.issues.order(:text)
    @issue = @issues.find(params[:issue_id]) if params[:issue_id]
  end
end

app/controllers/issues/merge_controller.rb
class Issues::MergeController < IssuesController

  def new
    @issues = []

    if params[:ids]
      ids = params[:ids].split(',')
      @issues = Issue.where(id: ids)
    end

    if @issues.count <= 1
      redirect_to projects_issues_url(current_project),
        alert: 'You need to select at least two issues to merge.'
    end
  end

  def create
    count = 0
    if params[:sources]

      # create new issue if existing issue not given
      if @issue.new_record?
        @issue.author ||= current_user.email
        if @issue.save && @issue.update(issue_params)
          track_created(@issue)
          @issue.tag_from_field_content!
        end
      end

      if @issue.persisted?
        source_ids = params[:sources].map(&:to_i) - [@issue.id]
        count = @issue.merge source_ids
      end

    end

    respond_to do |format|
      format.html {
        if count > 0
          redirect_to [current_project, @issue], notice: "#{count} #{'issue'.pluralize(count)} merged into #{@issue.title}."
        else
          redirect_to project_issues_path(current_project), alert: "Issues couldn't be merged."
        end
      }
      format.json
    end
  end

  private
  def liquid_resource_assigns; {}; end
end

app/controllers/issues/nodes_controller.rb
class Issues::NodesController < AuthenticatedController
  include ProjectScoped

  def show
    @node =
      Node.joins(:evidence)
          .select('nodes.id, label, type_id,
                  count(evidence.id) as evidence_count, nodes.updated_at')
          .where('evidence.issue_id = ? and nodes.id = ?',
                 params[:issue_id], params[:id])
          .first
    @instances = Evidence.where(issue_id: params[:issue_id], node: @node)

    render layout: false
  end
end

app/controllers/qa/issues_controller.rb
class QA::IssuesController < AuthenticatedController
  include ActivityTracking
  include LiquidEnabledResource
  include Mentioned
  include ProjectScoped

  before_action :set_issues
  before_action :set_issue, only: [:edit, :show, :preview, :update]
  before_action :validate_state, only: [:multiple_update, :update]

  def index
    @all_columns = @default_columns = ['Title']
  end

  def show; end

  def edit
    @form_cancel_path = project_qa_issue_path(current_project, @issue)
    @form_preview_path = preview_project_qa_issue_path(current_project, @issue)
    @tags = current_project.tags
  end

  def update
    if @issue.update(state: @state, updated_at: Time.now)
      track_state_change(@issue)
      redirect_to project_qa_issues_path(current_project), notice: 'State updated successfully.'
    else
      render :show, alert: @issue.errors.full_messages.join('; ')
    end
  end

  def multiple_update
    @issues = current_project.issues.where(id: params[:ids])

    respond_to do |format|
      if @issues.update_all(state: @state, updated_at: Time.now)

        @issues.each do |issue|
          track_state_change(issue)
        end

        format.html do
          if params[:return_to] == 'qa'
            redirect_to project_qa_issues_path(current_project), notice: 'State updated successfully.'
          else
            redirect_to project_issues_path(current_project), notice: 'State updated successfully.'
          end
        end
      else
        format.html { render :show, alert: @issues.errors.full_messages.join('; ') }
      end
    end
  end

  private

  def issue_params
    params.permit(:state)
  end

  def liquid_resource_assigns
    { 'issue' => IssueDrop.new(@issue) }
  end

  def set_issue
    @issue = @issues.find(params[:id])
  end

  def set_issues
    @issues = current_project.issues.ready_for_review
  end

  def validate_state
    if Issue.states.keys.include?(params[:state])
      @state = params[:state]
    else
      redirect_to project_qa_issues_path(current_project), alert: 'Something fishy is going on...'
    end
  end
end

app/helpers/issues_helper.rb
module IssuesHelper
  # ------------------------------------------------------------ Import plugins
  # Takes the output of the ImportPlugin (an array of hashes (with :title,
  # :description, :tags for each record) and creates a new Issue object for
  # each element.
  def issues_from_import_records(records)
    issues = []
    records.each_with_index do |record, index|
      issue = Issue.new do |issue|
        issue.id = index
        if record.is_a?(Dradis::Plugins::Import::Result)
          issue.text = record.description
        else
          issue.text = record.fetch(:description,
                        "#[Title]#\nThis plugin did not provide its results in the expected format.\n\n#[Description]#\nWe expect and array of hashes: [{:title, :description}, ...]")
        end
      end

      if !issue.fields.key?('Title')
        # most likely this is some sort of error, try the record's :title
        if record.is_a?(Dradis::Plugins::Import::Result)
          issue.text << "\n\n#[Title]#\n#{record.title}"
        else
          issue.text << "\n\n#[Title]#\n#{record[:title]}"
        end
      end

      # The content of the entry can come with a Tags field, but the plugin
      # can also set some (e.g. the entry's status - 'Draft', 'Pending')
      if record.tags.any?
        tag_list = record.tags.join(',')
        issue.text << "\n\n#[AddonTags]#\n#{tag_list}"
      end

      issues << issue
    end
    issues
  end

  # Output Bootstrap badges if the issue has any associated tags
  def issue_tags(issue)
    return unless issue.fields.key?('Tags') || issue.fields.key?('AddonTags')

    all_tags = []

    %w{Tags AddonTags}.each do |tag_field|
      next unless issue.fields.key?(tag_field)
      content_tags = issue.fields[tag_field].split(',')
      all_tags << content_tags.map do |tag_name|
        tag = Tag.new(name: tag_name.strip)

        content_tag :span, class: 'badge', style: "background-color: #{tag.color}" do
          h(tag.display_name)
        end
      end
    end

    all_tags.join(' ').html_safe
  end

  # ----------------------------------------------------------- /Import plugins
  def tag_and_name_for(issue, prefix = false)
    content_tag :span, class: 'issue-severity' do
      tag = issue.tags.first
      content =
        if tag
          [
            colored_icon_for_model(issue, 'fa-tag'),
            h(tag.display_name)
          ]
        else
          [
            content_tag(:i, nil, class: 'fa-solid fa-tag'),
            'No tag'
          ]
        end

      if prefix == true
        content.insert(1, 'Issue')
        content[2] = "(#{content[2]})"
      end

      content.join(' ').html_safe
    end
  end

  def state_icons
    state_icons = []
    Issue.states.keys.each do |state|
      case state
      when 'draft'
        state_icons << ['Draft', 'fa-pencil-square']
      when 'ready_for_review'
        state_icons << ['Ready for review', 'fa-eye']
      when 'published'
        state_icons << ['Published', 'fa-rocket']
      end
    end
    return state_icons
  end
end

app/views/qa/issues/_breadcrumbs.html.erb
<nav>
  <ol class="breadcrumb">
    <li class="breadcrumb-item"><%= link_to 'QA', project_qa_issues_path(current_project) %></li>
    <li class="breadcrumb-item active"><%= (@issue.title? ? @issue.title : "Issue ##{@issue.id}")%></li>
  </ol>
</nav>

app/views/qa/issues/_sidebar_item.html.erb
<%= content_tag :div, id: "#{dom_id(record)}_link", class: class_names('list-item', active: params[:id].to_i == record.id) do %>
  <%= link_to project_qa_issue_path(current_project, record) do %>
    <%= colored_icon_for_model(record, 'fa-bug', 'list-item-icon') %>
    <%= record.title %>
  <% end %>

  <div class="list-item-actions">
    <%= link_to edit_project_qa_issue_path(current_project, record), class:'list-item-action-edit' do %>
      <i class="fa-solid fa-pencil"></i> Edit
    <% end %>
  </div>
<% end %>

app/views/qa/issues/_widget.html.erb
<div class="content-container ms-xxl-3">
  <h4 class="header-underline">QA</h4>
  <p class="fw-bold mb-2">Update State</p>
  <div class="btn-group">
    <%= button_to 'Draft', project_qa_issue_path(current_project, id: @issue, state: 'draft'), method: :put, class: 'btn btn-secondary text-dark rounded-start' %>
    <div class="btn-placeholder rounded-0">Ready for review</div>
    <%= button_to 'Published', project_qa_issue_path(current_project, id: @issue, state: 'published'), method: :put, class: 'btn btn-secondary text-dark rounded-end' %>
  </div>
</div>

app/views/qa/issues/edit.html.erb
<% content_for :title, 'Edit issue' %>

<% content_for :sidebar do %>
  <%= render partial: 'qa/sidebar', locals: 
    { 
      index_path: project_qa_issues_path(current_project),
      name: 'issues_for_review',
      records: @issues
    }
  %>
<% end %>

<% content_for :breadcrumbs do %>
  <%= render partial: 'breadcrumbs' %>
<% end %>

<div class="content-container" id="issues_editor">
  <div class="note-text-inner">
    <h4 class="header-underline">Edit issue (<%= @issue.state.humanize %>)</h4>
    <!-- This div is needed to allow correct tabbing order in Chrome when page is loaded with turbolinks -->
    <div class="autofocus" autofocus="true" tabindex="1"></div>
    <%= render 'issues/form' %>
  </div>
</div>

app/views/qa/issues/index.html.erb
<% content_for :title, 'Quality Assurance' %>

<ul class="tabs-container nav nav-tabs main-tabs">
  <li class="nav-item">
    <%= link_to project_qa_issues_path(current_project), class: 'nav-link active' do %>
      <i class="fa-solid fa-bug"></i> Issues
    <% end %>
  </li>
</ul>

<div class="row m-0">
  <div class="col-12 p-0">
    <div class="content-container mt-0 pb-3" id="qa-viewer" data-behavior="qa-viewer">
      <% if @issues.any? %>
        <div data-behavior="datatable-paths"
             data-table-state-url="<%= multiple_update_project_qa_issues_path(current_project) %>"
             data-table-return-to="qa" >
          <%=
          render partial: 'issues/table', locals: {
            issues: @issues,
            local_storage_key: "project.ce.#{dom_id(current_project)}.qa_issues_datatable",
            qa_state_icons: state_icons.reject.with_index { |_, index| index == 1 },
          }
        %>
        </div>
      <% else %>
        <div class="empty-state mt-3">
          <div class="empty-state-icon">
            <%= image_tag "icons/#{rand(9)}.svg" %>
          </div>
          <div class="empty-state-body">
            <div class="container">
              <h4 class="empty-state-title">You don't have any issues to review yet.</h4>
              <p class="empty-state-body-text">Ensure the accuracy and completeness of your data by QA-ing issues. Once there are issues marked as 'ready for review' you'll be able to go through each one here, make any necessary changes, leave comments, publish, etc.</p>
              <div class="empty-state-actions">
                <a href="https://dradis.com/support/guides/projects/qa.html" class="empty-state-docs-link" target="_blank">More about QA</a>
              </div>
            </div>
          <% end %>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/qa/issues/show.html.erb
<% content_for :title, 'Quality Assurance' %>

<% content_for :breadcrumbs do %>
  <%= render 'breadcrumbs' %>
<% end %>

<% content_for :sidebar do %>
  <%= render partial: 'qa/sidebar', locals: 
    { 
      index_path: project_qa_issues_path(current_project),
      name: 'issues_for_review',
      records: @issues
    }
  %>
<% end %>

<div class="row m-0">
  <div class="col-12 col-xxl-7 p-0">
    <div class="content-container pb-3 me-xxl-3">
      <% cache ['issue-content', @issue] do %>
        <div class="note-text-inner">
          <h4 class="mb-4 header-underline align-items-center">
            <span class="text-truncate" title="<%= @issue.title %>"><%= @issue.title %></span>
            <%= render partial: 'shared/liquid_loading' %>
            <span class="actions">
              <span class="action">
                <%= link_to edit_project_qa_issue_path(current_project, @issue) do %>
                  <i class="fa-solid fa-pencil fa-fw"></i> Edit
                <% end %>
              </span>
            </span>
          </h4>
          <%= render partial: 'shared/textile_content', locals: { record: @issue, preview_path: preview_project_issue_path(current_project, @issue) } %>
          <div class="author-info">
            <span class="ms-auto">Author: <%= @issue.author || 'n/a' %></span>
          </div>
        </div>
      <% end %>
    </div>
  </div>

  <div class="col-12 col-xxl-5 p-0">
    <div class="sticky-top">
      <%= render partial: 'widget' %>

      <div class="content-container ms-xxl-3">
        <%= content_tag :div,
          spinner_tag,
          data: {
            behavior: 'fetch fetch-comments',
            path: comments_path(
              comment: {
                commentable_type: @issue.class,
                commentable_id: @issue.id
              }
            )
          }
        %>

        <%= render_view_hooks('issues/comments') %>
      </div>

      <div class="content-container ms-xxl-3">
        <%= content_tag :div,
          spinner_tag,
          data: {
            behavior: 'fetch fetch-subscriptions',
            path: subscriptions_path(
              subscription: {
                subscribable_type: @issue.class,
                subscribable_id: @issue.id
              }
            )
          }
        %>
      </div>
    </div>
  </div>
</div>